

					Include	windows.inc
					Include user32.inc
					Include kernel32.inc
					Include comctl32.inc

					IncludeLib USER32.LIB
					IncludeLib KERNEL32.LIB
					IncludeLib comctl32.lib

					get_pw_info	PROTO	:DWORD
					set_pw_info	PROTO	:DWORD


					;************************************************
					;*				Database Equates				*
					;************************************************
MAX_GP_COUNT		equ		1024					; maximum number of groups
MAX_PW_COUNT		equ		1024					; maximum number of passwords
MAX_WD_COUNT		equ		8192					; maximum number of strings
MAX_WD_MEM			equ		8192					; maximum memory size for word database

					;************************************************
					;*						Equates					*
					;************************************************
IDD_MAIN			EQU 	101
IDD_DLG1			EQU 	102
IDD_DLG2			EQU 	103
IDD_DLG3			EQU 	104
IDC_OK				EQU 	1001
IDC_TABCONTROL		EQU 	1002
IDC_STATIC			EQU 	1010
IDC_STATICONE		EQU 	1004
IDC_EDITONE			EQU 	1005
IDC_STATICTWO		EQU 	1006
IDC_EDITTWO			EQU 	1007
IDC_STATICTHREE		EQU 	1008
IDC_EDITTHREE		EQU 	1009

IDC_STATUSBAR		equ		1011
IDC_TVW_Group 		equ		1013
IDC_BTN_ADDGP 		EQU 	1014 
IDC_BTN_DELGP 		EQU 	1015 

IDC_GPBOX_CONTROL 	EQU 	1019

IDC_STATIC1017  	EQU 	1017
IDC_STATIC1025  	EQU 	1025
IDC_STATIC1026  	EQU 	1026
IDC_STATIC1027   	EQU 	1027
IDC_STATIC1028   	EQU 	1028
IDC_STATIC1029   	EQU 	1029

IDC_EDT_GPNAME 		EQU 	1018   
IDC_BTN_ADDPW 		EQU 	1020    
;IDC_BTN_EDITPW 		EQU 	1021   
IDC_BTN_DELPW 		EQU 	1022    
IDC_EDT_WebName 	EQU 	1030  
IDC_EDT_URL 		EQU 	1031      
IDC_EDT_UserName 	EQU 	1032 
IDC_EDT_Password 	EQU 	1033 
IDC_EDT_Remark 		EQU 	1034   
IDC_GPBOX_PassWord	equ		1016

IDC_EDT_NewGp		equ		1037
IDC_LBL_GpName		equ		1036

IDC_BTN_NEWGP 		equ		1038

IDC_EDT_GP_CNT		equ		1040
IDC_BTN_EDITPW 		equ		1041

					;************************************************
					;*			Initialized data segment			*
					;************************************************
					.DATA
AppName				db	" Password wallet ",0
szDlgOne			DB 	" Group Password Entry ",0
szDlgTwo			DB 	"Two",0
szDlgThree			DB	"Three",0

ClassName 			db 	"TreeViewWinClass",0
TreeViewClass 		db 	"SysTreeView32",0

szAddGpN			db	"New Group",0
szAddGpA			db	"Add Group",0
szDelGpN			db	"Delete Group",0
szDelGpC			db	"Cancel",0
szDelGpO			db	"OK",0

szAddPwN			db	"New",0
szAddPwA			db	"Add",0
szDelPwN			db	"Delete",0

szParent         	db  "Groups",0

;*==============	Messages	==============================================
Msg_noGroupSel		db	"Error: No group name selected for password to reference to. Select group to insert password",0

Msg_NewGpName		db	"New Group name inserted into database - "
szNewGpName			db	32 dup (0)				;

					;************************************************
					;*			Uninitialized data segment			*
					;************************************************
					.DATA?
tvi				TV_ITEM		<?>
tvis           	TV_INSERTSTRUCT      <?>

hInstance			dd	?
hGpBoxPassword		dd	?						; password group box handle 
hAddGroup			dd	?						; add group button handle
hDelGroup			dd	?						; delete group button handle
hNewGroup			dd	?						; new group button handle

hAddPassW			dd	?						; add password button handle
hDelPassW			dd	?						; delete password button handle
hEditPassW			dd	?						; edit password button handle

hEDTGpName			dd	?						; group name edit control handle
hEDTWebName			dd	?						; web name edit control handle
hEDTURL				dd	?						; URL name edit control handle
hEDTUserName		dd	?						; user name edit control handle
hEDTPassword		dd	?						; passwork edit control handle
hEDTRemark			dd	?						; remark edit control handle
hEDTGpCnt			dd	?						; group name count edit control handle

hLBLGpName			dd	?						; label group name handle
hEDTNewGp			dd	?						; new group name edit control handle

hLBL_1017			dd	?						; 
hLBL_1025			dd	?						; 
hLBL_1026			dd	?						; 
hLBL_1027			dd	?						; 
hLBL_1028			dd	?						; 
hLBL_1029			dd	?						; 

hStatus				dd	?						; statusbar handle

hTvwGroup			dd	?						;

;*=========	Tab page handles	=========================================
hTabDlg				dd	3 dup (?)				;

;*=========	Password control state variable	=============================
iPWstate			dd	?						; password group state

;*=========	New group name control state variable	=====================
iGpNamestate		dd	?						; group name state

;*=========	New group button state	=====================================
;*=========	"N" state - 'New' IDC_BTN_ADDGP and 'Delete' buttons IDC_BTN_DELGP
;*=========	"I" state - 'Add' IDC_BTN_ADDGP and 'Cancel' buttons IDC_BTN_DELGP
;*=========	"D" state - 'Cancel' IDC_BTN_ADDGP and 'OK' buttons IDC_BTN_DELGP
bNewName			db	?						; new name button state

;*=========	Password button state	=====================================
;*=========	"N" state - 'New' IDC_BTN_ADDPW and 'Delete' buttons IDC_BTN_DELPW
;*=========	"I" state - 'Add' IDC_BTN_ADDPW and 'Cancel' buttons IDC_BTN_DELPW
;*=========	"D" state - 'Cancel' IDC_BTN_ADDPW and 'OK' buttons IDC_BTN_DELPW
bPassword			db	?						; new name button state

bSelected			db	?							; treeview item selected: 0 = No, 1 = Yes

;*=========		Tree Handle		===========================================================
hParent			dd		?							; parent handle to treeview
hItem  			dd		?							; subsequent item handle
hChild 			dd		?							; child item handle
hLevel			dd		?							; current level handle

;*=========	File variables	============================================================
hFile			dd		?							; file handle
i_byteread		dd		?							; bytes read
FileError		dd		?							; file error code
FilePath		db		255 dup (?)					; 


;*======================================================================================*
;*			Database structure															*
;*--------------------------------------------------------------------------------------*
;*			There are 3 sub-databases:													*
;*			1.	Word database - this database contains all the strings, from group		*
;*				name to remark. They are saved in Pascal style format sequentially		*
;*				indexed. All reference to them uses their index. The index is zero		*
;*				based. Database name: Word.dat											*
;*			2.	Password database - this database contains a record of the password		*
;*				information. All the fields which are strings refer to the strings		*
;*				in the word database. Each field has an index, from the group name		*
;*				to the remark. All indexes are zero based. Unused fields are denoted	*
;*				with -1 (0FFFFFFFFh). Database name: PW.dat								*
;*			3.	Group database - list of all the group name that have been defined		*
;*				The database contains the group name indexes. Database name: GP.dat		*
;*																						*
;*			All three databases are stored separately.									*
;*--------------------------------------------------------------------------------------*
;*			Password database															*
;*			-----------------															*
;*			Offset	Description				Byte count									*
;*			======	===========				==========									*
;*			 0 -3	Group name index			4										*
;*			 4 -7	Website name				4										*
;*			 8 -11	URL							4										* 
;*			 12-15	User name					4										* 
;*			 16-19	Password					4										* 
;*			 20-24	Remark						4										* 
;*																						*
;*			When more than one password is inserted into the same groupname, the		*
;*			database will insert the new password sequentially and in ascending			*
;*			of the website name.														*
;*																						*
;*			The database will manage the insertion and deletion of each record.			*
;*======================================================================================*
PWrec				struct
	ixGpName		dd	?						; groupname index
	ixWebName		dd	?						; web name index
	ixURL			dd	?						; URL index
	ixUserName		dd	?						; username index
	ixPassWord		dd	?						; password index
	ixRemark		dd	?						; remark index
PWrec				ends

PWBSize				equ	sizeof PWrec			; password record byte count

;*=========	Same groupname indexes search buffer	=====================
iindxCnt			dd	?						; number of indexes found
iindxList			dd	1024 dup (?)			;  groupname indexes list

;*=========	Database variables	=========================================
sNewGroup			db	32 dup (?)				; new group name buffer
sWebName			db	32 dup (?)				; web name buffer
sURL				db	255 dup (?)				; URL name
sUserName			db	32 dup (?)				; username
sPassWord			db	255 dup (?)				; password
sRemark				db	255 dup (?)				; remark
sItem				db	32 dup (?)				; 

iPWCount			dd	?						; number of passwords
icurPw				dd	?						; current password index in password database
inewPw				dd	?						; new password index in password database
isrchPw				dd	?						; found password index in password database
idPw				dd	?						; number of password records deleted

insPw				dd	?						; new start password index in word database
icsPw				dd	?						; current start password index in word database
issPw				dd	?						; searched start password index in word database

pnPw				dd	?						; ptr to new password information record in word database
pnPwWd				dd	?						; ptr to new start password information in password database, i.e. 1st field
psPw				dd	?						; ptr to found searched password information record in password database

iGpCount			dd	?						; number of groups
icurGp				dd	?						; current group index in database
inewGp				dd	?						; new group index in database
isrchGp				dd	?						; found grou index in database
idGP				dd	?						; number of groupname records deleted
pnGp				dd	?						; ptr to new groupname record in group database
pnGpWd				dd	?						; ptr to new group name record in word database,
psGp				dd	?						; ptr to found searched group name record in group database

;*=========	Databases	================================================
GpDB				db	MAX_GP_COUNT dup (?)	; 
PWDB				db	MAX_PW_COUNT*PWBSize dup (?)	;

;*========	Pointer to calling routine's registers	====================
bWdType				db	?						; 1 = Group, 2 = Password
pStrWd				dd	?						; pointer to start of data to be inserted into database
pCount				dd	?						; pointer to record count
pcIndx				dd	?						; pointer to current index
pnIndx				dd	?						; pointer to new index
psIndx				dd	?						; pointer to search index
pcDB				dd	?						; pointer to start of database
psDB				dd	?						; pointer to source database (group/password)
iCpyCnt				dd	?						; number of string to copy


;*========	Word database	============================================
iWdCount			dd	?						; number of words in word database
icWd				dd	?						; current word index in word database, zero based
isWd				dd	?						; found search word index in word database, zero based
inWd				dd	?						; new word index in word database, zero based
iRemMem				dd	?						; remaining memory in word database

pNxtWd				dd	?						; pointer to next free space in word database
pcWd				dd	?						; pointer to current word in word database
psWd				dd	?						; pointer to found search word in word database
pnWd				dd	?						; pointer to new word in word database

WDDB				db	MAX_WD_MEM dup (?)
